#!/usr/bin/perl
###################################################################
# VacationAdm Webmin module                                       #
###################################################################
#                                                                 #
# $Id: vacation.cgi,v 1.1.1.1 2003/02/27 22:18:24 martin Exp $
#                                                                 #
###################################################################
#                                                                 #
# Module allows for admins and users to alter their .forward with #
# authentication through FTP.  This module is given freely, with  #
# no responsibility for its use or upkeep to be placed on the     #
# author. I am, of course interested in ideas on improving things #
# so email: devil@medialab.at                                     #
#                                                                 #
###################################################################
#                                                                 #
# vacation.cgi                                                    #
#    This script receives input from the index.cgi HTML form.     #
#    If the form input 'mode' has a value of 'unset', then the    #
#    script FTPs to the server housing the user with their login  #
#    information and deletes the vacation related files.          #
#    If 'mode'=set, then the appropiate files are first created   #
#    as temp files in /tmp and then FTPed to the user directory.  #
#    NOTE:  You need to have libnet to use Net::FTP               #
#    In local or admin mode the libnet Module is not required if  #
#    webmin is installed on your mailhost.                        #
#                                                                 #
###################################################################
do '../web-lib.pl';
do 'local-lib.pl';

# We only need this module if we want ftp uploads
if ($config{'mode'} eq "ftp") {
    require Net::FTP;
}
else {
    use File::Copy;
    use File::stat;
}

umask(077);				# be secretive about files

$tmp="/tmp/list.$$";			# a temp file

# We use Post/Get Method to send some variables

&ReadParse();

$mess=	   $in{'mess'};		# vacation message
$fwrd=     $in{'fwrd'};         # optional email address(es) to be forwarded to
$user=     $in{'user'};		# your login name
$pass=     $in{'pass'};		# your login password
$act_vac=  $in{'activate'};	# set or unset vacation
$act_fwd=  $in{'activate_fwd'};	# set or unset forwarding
$hold=     $in{'hold'};		# hold or delete the mail

# To unset vacation service remove all files created
sub unset_vacation {

    # if mode is FTP, we use ftp to create the files, otherwise we do
    # local file operations.
    if ( $config{'mode'} eq "ftp" ) {
	&unset_vacation_via_ftp;
	}
    else {
	&unset_vacation_local;
	}

    # Report the success
    &html_open();
    print "<HR>\n";
    print "<CENTER><TABLE BORDER=1>\n";
    print "<TR $tb ALIGN=center><TD><H3><STRONG>";
    print $text{'vacation_success'};
    print "</STRONG></H3></TD></TR>\n";
    print "<TR $cb ALIGN=center><TD>";
    print "<H3>".$text{'vacation_success_remove'}." <I>$user</I></H3>";
    print "</TD></TR>\n";
    print "</TABLE></CENTER>\n";

    print "<CENTER><P>$text{'use_the_link'}</P></CENTER>\n<HR>\n";
    &html_close();
}



# To set vacation service create:
#	.vacation.msg	-- the message
#	.vacation.pag	-- data base history
#	.vacation.dir	-- data base history
#	.forward	-- to pipe to user and vacation service.
sub set_vacation {

    # if mode is FTP, we use ftp to create the files, otherwise we do
    # local file operations.
    if ( $config{'mode'} eq "ftp" ) {
	&set_vacation_via_ftp
	}
    else {
	&set_vacation_local
	}

    # Close it off and report ok
    &html_open();
    print "<HR>\n";
    print "<CENTER><TABLE BORDER=1>\n";
    print "<TR $tb ALIGN=center><TD><H3><STRONG>";
    print $text{'vacation_success'};
    print "</STRONG></H3></TD></TR>\n";
    print "<TR $cb ALIGN=center><TD>";
    print "<H3>".$text{'vacation_success_install'}." <I>$user</I></H3>" .
	( ( defined($aliasename) && length($aliasename)>0 )
	  ? ("<br>(aliases: " . $aliasename . ")")
	  : "");
    print "</TD></TR>\n";
    print "</TABLE></CENTER>\n";

    print "<CENTER><P>$text{'use_the_link'}</P></CENTER>\n<HR>\n";
    &html_close();
}



##############################################################################
#                           The main program                                 #
##############################################################################

# Gotta be invoked by the right methods
($ENV{'REQUEST_METHOD'} eq 'POST') ||
	&html_abort($text{'abort_wrong_methode'});

# if user is only allowed to change psersonal settings,
# reset username to be sure everything is correct.
my %access = &get_module_acl();
if ( $access{'editing'} eq "this" ) {
    $user = $ENV{'REMOTE_USER'};
}

# Always need name
&html_abort($text{'abort_no_login_name'})
	unless (defined($user) && $user =~ /./);

# May do set vacation or unset (ie. remove).
if ($act_vac eq "set" || $act_fwd eq "set") {
    if ($act_vac eq "set" && !(defined($mess) && $mess =~ /./ )) {
	&html_abort($text{'abort_no_message'});
    }
    elsif ( $act_fwd eq "set" && defined($fwrd) && $fwrd eq "<$text{'index_forward_msg'}>") {
	&html_abort($text{'abort_no_forwarders'});
	$act_fwd="unset";
    }
    &set_vacation();
}
else {
    &unset_vacation();
}

# end of file
